package com.jiuqi.util.inifile;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.jiuqi.util.MemStream;
import com.jiuqi.util.Stream;
import com.jiuqi.util.StreamException;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public abstract class IniBuffer {
  private int writeCount = 0;
  
  private int readCount = 0;
  
  public abstract int getEntry();
  
  public abstract void writeEntry();
  
  public abstract boolean gotoEntry(boolean paramBoolean);
  
  public abstract void gotoCursor();
  
  public abstract void writeInfoBoolean(boolean paramBoolean);
  
  public abstract void writeInfoDouble(double paramDouble);
  
  public abstract void writeInfoInteger(int paramInt);
  
  public abstract void writeInfoLong(long paramLong);
  
  public abstract void writeInfoString(String paramString);
  
  public abstract void writeInfoByte(byte paramByte);
  
  public abstract boolean readInfoBoolean();
  
  public abstract double readInfoDouble();
  
  public abstract int readInfoInteger();
  
  public abstract long readInfoLong();
  
  public abstract String readInfoString();
  
  public abstract byte readInfoByte();
  
  public abstract int writeBoolean(boolean paramBoolean);
  
  public abstract int writeDouble(double paramDouble);
  
  public abstract int writeInteger(int paramInt);
  
  public abstract int writeLong(long paramLong);
  
  public abstract int writeString(String paramString);
  
  public abstract boolean readBoolean(int paramInt);
  
  public abstract double readDouble(int paramInt);
  
  public abstract int readInteger(int paramInt);
  
  public abstract long readLong(int paramInt);
  
  public abstract String readString(int paramInt);
  
  public abstract int writeStream(Stream paramStream, int paramInt);
  
  public abstract void readStream(Stream paramStream, int paramInt1, int paramInt2);
  
  public abstract void loadFromStream(Stream paramStream);
  
  public abstract void replaceStream(Stream paramStream);
  
  public abstract void saveToStream(Stream paramStream);
  
  public final boolean verify() {
    return gotoEntry(true);
  }
  
  public void beginWrite() {
    if (this.writeCount == 0)
      gotoCursor(); 
    this.writeCount++;
  }
  
  public boolean writeing() {
    return (this.writeCount > 0);
  }
  
  public void endWrite() {
    this.writeCount--;
  }
  
  public void beginRead() {
    this.readCount++;
  }
  
  public boolean reading() {
    return (this.readCount > 0);
  }
  
  public void endRead() {
    this.readCount--;
  }
  
  public void loadFromFile(String fileName) throws StreamException, IOException {
    MemStream memStream = new MemStream();
    memStream.setPosition(0L);
    memStream.loadFromFile(fileName);
    loadFromStream((Stream)memStream);
  }
  
  public void saveToFile(String fileName) throws StreamException, IOException {
    MemStream memStream = new MemStream();
    saveToStream((Stream)memStream);
    memStream.saveToFile(fileName);
  }
  
  public void loadFromStream(InputStream inStream) throws StreamException, IOException {
    MemStream memStream = new MemStream();
    memStream.setPosition(0L);
    memStream.loadFromStream(inStream);
    loadFromStream((Stream)memStream);
  }
  
  public void saveToStream(OutputStream outStream) throws StreamException, IOException {
    MemStream memStream = new MemStream();
    saveToStream((Stream)memStream);
    memStream.saveToStream(outStream);
  }
}
